/*******************************************************************************
 * FoxHUDUI_PL generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxHUDUI_PL extends FoxHudUI_TDM within FoxUI
    native(HUD)
    config(HUD);

struct native ProgressBarStats
{
    var float MoverProgress;
    var int MoverDirection;
    var float BlueBarProgress;
    var float OrangeBarProgress;
    var int NumControlPoints;
    var int ControlPointIndex;

    structdefaultproperties
    {
        MoverProgress=0.0
        MoverDirection=0
        BlueBarProgress=0.0
        OrangeBarProgress=0.0
        NumControlPoints=0
        ControlPointIndex=0
    }
};

var const localized string LocOffenseTeamName;
var const localized string LocDefenseTeamName;
var const localized array<localized string> GameplayDetailEscort;
var const localized array<localized string> GameplayDetailDefense;
var const localized string PayloadName;
var FoxProgressBarWidget PayloadBarWidget;
var ProgressBarStats CurrentBarStats;
var int CachedControlPointIndex;

function SetupGameTypeWidget()
{
    local GFxObject AttachPanel;

    // End:0x3E
    if(IsOnAttackingTeam())
    {
        AddGameTypeWidget("PAYLOAD", 0, LocDefenseTeamName, LocOffenseTeamName, "SIEGE");
    }
    // End:0x6C
    else
    {
        AddGameTypeWidget("PAYLOAD", 0, LocOffenseTeamName, LocDefenseTeamName, "SIEGE");
    }
    AttachPanel = Outer.GetVariableObject("_root.gametypeWidgetName");
    // End:0x162
    if(PayloadBarWidget == none)
    {
        PayloadBarWidget = FoxProgressBarWidget(AttachPanel.AttachMovieClip("w_gametypeProgressBar", "FoxPayloadWidget", class'FoxProgressBarWidget'));
        PayloadBarWidget.Initialize();
        PayloadBarWidget.ShowMoverArrow(true);
    }
    CachedControlPointIndex = default.CachedControlPointIndex;
    //return;    
}

function CleanUpGameTypeWidget()
{
    PayloadBarWidget.RemoveMovieClip();
    PayloadBarWidget = none;
    //return;    
}

function UpdateProgressBarPosition(float Progress)
{
    // End:0x84
    if(IsOnAttackingTeam())
    {
        PayloadBarWidget.SetMoverProgress(Progress);
        PayloadBarWidget.SetLeftTeamProgress(Progress);
        PayloadBarWidget.SetRightTeamProgress(0.0);
    }
    // End:0xFF
    else
    {
        PayloadBarWidget.SetMoverProgress(1.0 - Progress);
        PayloadBarWidget.SetRightTeamProgress(Progress);
        PayloadBarWidget.SetLeftTeamProgress(0.0);
    }
    //return;    
}

function UpdateProgressBarDirection(int Direction)
{
    // End:0x6F
    if(Direction == 0)
    {
        PayloadBarWidget.SetMoverDirection(0);
        PayloadBarWidget.SetMoverOwnerColor(PayloadBarWidget.NeutralColor);
    }
    // End:0x21B
    else
    {
        // End:0x14D
        if(IsOnAttackingTeam())
        {
            // End:0xED
            if(Direction == 2)
            {
                PayloadBarWidget.SetMoverDirection(2);
                PayloadBarWidget.SetMoverOwnerColor(PayloadBarWidget.BlueColor);
            }
            // End:0x14A
            else
            {
                PayloadBarWidget.SetMoverDirection(1);
                PayloadBarWidget.SetMoverOwnerColor(PayloadBarWidget.OrangeColor);
            }
        }
        // End:0x21B
        else
        {
            // End:0x1BD
            if(Direction == 2)
            {
                PayloadBarWidget.SetMoverDirection(1);
                PayloadBarWidget.SetMoverOwnerColor(PayloadBarWidget.OrangeColor);
            }
            // End:0x21B
            else
            {
                PayloadBarWidget.SetMoverDirection(2);
                PayloadBarWidget.SetMoverOwnerColor(PayloadBarWidget.BlueColor);
            }
        }
    }
    //return;    
}

event bool IsOnAttackingTeam()
{
    // End:0x14A
    if(((Outer.PCOwner.PlayerReplicationInfo != none) && Outer.PCOwner.PlayerReplicationInfo.Team != none) && FoxSiegeTeamInfo(Outer.PCOwner.PlayerReplicationInfo.Team) != none)
    {
        return FoxSiegeTeamInfo(Outer.PCOwner.PlayerReplicationInfo.Team).bIsAttackingTeam;
    }
    return false;
    //return ReturnValue;    
}

event UpdateProgressBar()
{
    local int I, NumNeutral, BlueTeamControlPoints;

    // End:0x11
    if(PayloadBarWidget == none)
    {
        return;
    }
    UpdateProgressBarDirection(CurrentBarStats.MoverDirection);
    UpdateProgressBarPosition(CurrentBarStats.MoverProgress);
    // End:0x2C2
    if(CachedControlPointIndex != CurrentBarStats.ControlPointIndex)
    {
        // End:0xB9
        if(CachedControlPointIndex != -1)
        {
            PayloadBarWidget.FlashMover();
        }
        CachedControlPointIndex = CurrentBarStats.ControlPointIndex;
        BlueTeamControlPoints = ((IsOnAttackingTeam()) ? CachedControlPointIndex : 0);
        NumNeutral = BlueTeamControlPoints + (CurrentBarStats.NumControlPoints - CachedControlPointIndex);
        PayloadBarWidget.SetNumControlPoints(CurrentBarStats.NumControlPoints);
        I = 0;
        J0x184:
        // End:0x2C2 [Loop If]
        if(I < CurrentBarStats.NumControlPoints)
        {
            // End:0x20E
            if(I < BlueTeamControlPoints)
            {
                PayloadBarWidget.SetControlPointColor(I, PayloadBarWidget.BlueColor);
            }
            // End:0x2B4
            else
            {
                // End:0x26E
                if(I < NumNeutral)
                {
                    PayloadBarWidget.SetControlPointColor(I, PayloadBarWidget.NeutralColor);
                }
                // End:0x2B4
                else
                {
                    PayloadBarWidget.SetControlPointColor(I, PayloadBarWidget.OrangeColor);
                }
            }
            ++ I;
            // [Loop Continue]
            goto J0x184;
        }
    }
    //return;    
}

function array<string> GetGameplayDetailStrings()
{
    // End:0x1A
    if(IsOnAttackingTeam())
    {
        return GameplayDetailEscort;
    }
    // End:0x24
    else
    {
        return GameplayDetailDefense;
    }
    //return ReturnValue;    
}

defaultproperties
{
    LocOffenseTeamName="ESCORT"
    LocDefenseTeamName="DEFENSE"
    GameplayDetailEscort(0)="Escort team guards the Scorpion Tank to the goal area before the time runs out"
    GameplayDetailDefense(0)="Defense team must prevent the Scorpion Tank from reaching the goal area"
    PayloadName="SCORPION"
    CachedControlPointIndex=-1
    GameplayDetailStrings(0)="Escort team guards the Scorpion Tank to the goal area before the time runs out"
    GameplayDetailStrings(1)="Defense team must prevent the Scorpion Tank from reaching the goal area"
    GameplayDetailStrings(2)="Have fun!"
}